package cc.periphs;

import lua.Table;

interface ReducedItemInfo {
	public var count:Int;
	public var name:String;
	public var nbt:Null<String>;
}

interface DetailedItemInfo extends ReducedItemInfo {
	public var displayName:String;
	public var tag:Null<String>;
	public var maxCount:Int;
	public var tags:Table<String, Bool>;
	public var durability:Null<Float>;
	public var damage:Null<Int>;
	public var maxDamage:Null<Int>;
	public var enchantments:Null<Array<{displayName:String, level:Int, name:String}>>;
}

extern class ItemStorage {
	public function size():Int; //	Get the size of this inventory.
	public function list():Table<Int, ReducedItemInfo>; //	List all items in this inventory.
	public function getItemDetail(slot:Int):DetailedItemInfo; //	Get detailed information about an item.
	public function pushItems(toName:String, fromSlot:Int, ?limit:Int, ?toSlot:Int):Int; //	Push items from one inventory to another connected one.
	public function pullItems(fromName:String, fromSlot:Int, ?limit:Int, ?toSlot:Int):Int; //	Pull items from a connected inventory into this one.
	public function getItemLimit(slot:Int):Int; // Get the maximum number of items which can be stored in this slot.
}
